﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Doplnovani_posloupnosti
{
    class Program
    {
        static void Main(string[] args)
        {
            ProgramIO programIO = new ProgramIO();
            List<Posloupnost> posloupnosti = new List<Posloupnost>();

            Console.WriteLine("Vítejte v aplikaci: Doplňování posloupností");
            Console.WriteLine("Stisknutím libovolného tlačítka načtete soubor: 'input.txt'");
            Console.ReadKey();
            Console.Clear();

            try
            {
                posloupnosti = programIO.NactiPosloupnosti();
            }
            catch (FileNotFoundException)
            {
                Console.WriteLine("Soubor nebyl nalezen.");
                Console.WriteLine("Stisknutím libovolného tlačítka odejdete.");
                Console.ReadKey();
                return;
            }

            // Nemam rad, kdyz nazvy promennych, metod nebo trid jsou moc dlouhe. Prvni je NajdiPosloupnosti a druha je VypisPokracovaniPosloupnosti
            NajdiPosl(posloupnosti);
            VypisPokracPosl(posloupnosti);

            if (ChceVypsatDoSouboru())
            {
                if (programIO.VypisPosloupnosti(posloupnosti))
                    Console.WriteLine("Zapsáno.");
            }

            Console.WriteLine("Stisknutím libovolného tlačítka odejdete.");
            Console.ReadKey();
        }

        static void NajdiPosl(List<Posloupnost> posloupnosti)
        {
            foreach (Posloupnost posloupnost in posloupnosti)
            {
                if (posloupnost.ChybnyVstup || posloupnost.Cisla.Count < 8)
                    continue;

                float rozdil_0 = 0;
                float rozdil_1 = 0;
                float rozdil_rozdilu = 0;
                float podil_rozdilu = 1;

                for (int i = 1; i < posloupnost.Cisla.Count - 3; i++)
                {
                    rozdil_0 = posloupnost.Cisla[i] - posloupnost.Cisla[i - 1];
                    rozdil_1 = posloupnost.Cisla[i + 1] - posloupnost.Cisla[i];

                    if (rozdil_0 != rozdil_1)
                    {
                        rozdil_rozdilu = rozdil_1 - rozdil_0;
                        podil_rozdilu = rozdil_1 / rozdil_0;

                        if (posloupnost.Cisla[i + 1] + (rozdil_1 + rozdil_rozdilu) == posloupnost.Cisla[i + 2])
                        {
                            // Rozdil se pricita
                            podil_rozdilu = 1;
                        }
                        else if (posloupnost.Cisla[i + 1] + (rozdil_1 * podil_rozdilu) == posloupnost.Cisla[i + 2])
                        {
                            // Rozdil se nasobi
                            rozdil_rozdilu = 0;
                        }
                    }
                }

                float posledni_rozdil = posloupnost.Cisla[posloupnost.Cisla.Count - 1] - posloupnost.Cisla[posloupnost.Cisla.Count - 2];

                posloupnost.Rozdil_Rozdilu = rozdil_rozdilu;
                posloupnost.Podil_Rozdilu = podil_rozdilu;
                posloupnost.Posledni_Rozdil = posledni_rozdil;
            }
        }

        static void VypisPokracPosl(List<Posloupnost> posloupnosti)
        {
            foreach (Posloupnost posloupnost in posloupnosti)
            {
                Console.Write((posloupnosti.IndexOf(posloupnost) + 1) + ". ");

                if (posloupnost.ChybnyVstup)
                {
                    Console.Write("Chybný vstup\n");
                    continue;
                }
                else if (posloupnost.Cisla.Count < 8)
                {
                    Console.Write("Málo čísel ve vstupu\n");
                    continue;
                }

                float posledni_rozdil = posloupnost.Posledni_Rozdil;
                float posledni_cislo = posloupnost.Cisla[posloupnost.Cisla.Count - 1];

                for (int i = 0; i < 8; i++)
                {
                    float cislo_vystup = (posledni_cislo + (posledni_rozdil * posloupnost.Podil_Rozdilu + posloupnost.Rozdil_Rozdilu));
                    posledni_rozdil = cislo_vystup - posledni_cislo;
                    posledni_cislo = cislo_vystup;

                    posloupnost.NasledujiciCisla.Add(cislo_vystup);
                    Console.Write(cislo_vystup + " ");
                }

                Console.WriteLine();
            }
        }

        static bool ChceVypsatDoSouboru()
        {
            Console.WriteLine("\nPřejete si výsledek vypsat do souboru? [a/n]:");
            string vstup = Console.ReadLine().ToLower().Trim();

            while (true)
            {
                switch (vstup)
                {
                    case "a":
                        return true;
                    case "n":
                        return false;
                    default:
                        Console.WriteLine("Špatně zadaný vstup. Zadejte ho znovu:");
                        vstup = Console.ReadLine().ToLower().Trim();
                        break;
                }
            }
        }
    }
}
