﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Doplnovani_posloupnosti
{
    class ProgramIO
    {
        public List<Posloupnost> NactiPosloupnosti()
        {
            List<Posloupnost> posloupnosti = new List<Posloupnost>();

            string[] radky = File.ReadAllLines("input.txt");

            foreach (string radek in radky)
            {
                string[] strCisla = radek.Split(',');
                Posloupnost posloupnost = new Posloupnost();

                foreach (string strCislo in strCisla)
                {
                    try
                    {
                        posloupnost.Cisla.Add(int.Parse(strCislo));
                    }
                    catch
                    {
                        posloupnost.ChybnyVstup = true;
                        break;
                    }
                }

                posloupnosti.Add(posloupnost);
            }

            return posloupnosti;
        }

        public bool VypisPosloupnosti(List<Posloupnost> posloupnosti)
        {
            if (File.Exists("output.txt"))
            {
                Console.WriteLine("Soubor: 'output.txt' již existuje. Chcete ho přepsat? [a/n]:");
                string vstup = Console.ReadLine().ToLower().Trim();

                bool platny_vstup = true;
                while(platny_vstup)
                {
                    switch (vstup)
                    {
                        case "a":
                            platny_vstup = false;
                            break;
                        case "n":
                            platny_vstup = false;
                            break;
                        default:
                            Console.WriteLine("Špatně zadaný vstup. Zadejte ho znovu:");
                            vstup = Console.ReadLine().ToLower().Trim();
                            break;
                    }
                }

                if (vstup == "n")
                    return false;
            }

            using (StreamWriter writer = new StreamWriter("output.txt", false))
            {
                foreach (Posloupnost posloupnost in posloupnosti)
                {
                    writer.WriteLine();

                    if (posloupnost.ChybnyVstup)
                    {
                        writer.Write("Chybný vstup.");
                    }
                    else if (posloupnost.Cisla.Count < 8)
                    {
                        writer.Write("Málo čísel ve vstupu");
                    }

                    for (int i = 0; i < posloupnost.NasledujiciCisla.Count; i++)
                    {
                        writer.Write(posloupnost.NasledujiciCisla[i]);

                        if (i != posloupnost.NasledujiciCisla.Count - 1)
                            writer.Write(",");
                    }
                }
            }

            return true;
        }
    }
}
