﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Posloupnost
{
    /// <summary>
    /// reprezentuje jednu posloupnost
    /// </summary>
    public class Posloupnost
    {
        public List<int> VstupniCleny { get; set; }
        public List<int> Diference { get; set; }
        public List<int> DalsiCleny { get; set; }

        public Posloupnost()
        {
            VstupniCleny = new List<int>();
            Diference = new List<int>();
            DalsiCleny = new List<int>();
        }

        public override string ToString()
        {
            string posloupnost = VratClenyPosloupnost(VstupniCleny) + " -> " + VratClenyPosloupnost(DalsiCleny);         

            return posloupnost;
        }

        /// <summary>
        /// pomocná metoda pro ToString()
        /// </summary>
        /// <param name="posloupnost"></param>
        /// <returns></returns>
        private string VratClenyPosloupnost(List<int> posloupnost)
        {
            string clenyPosloupnosti;

            if (posloupnost.Any())
            {
                clenyPosloupnosti = posloupnost[0].ToString();

                for (int i = 0; i < posloupnost.Count - 1; i++)
                {
                    clenyPosloupnosti += ", " + posloupnost[i + 1].ToString();
                }
            }
            else
            {
                clenyPosloupnosti = "Netuším, co to je za posloupnost.";
            }      

            return clenyPosloupnosti;
        }
    }

    class Program
    {
        //Čau, předem se omlouvám za svůj kód, mám jen základy programování (u nás na škole se programování vůbec neučí) a naposledy jsem programoval asi tak před půl rokem, takže hádám, že by to šlo napsat mnohem lépe. 
        //Každopádně bych chtěl poděkovat za soutěž, byla celkem "lehká" (i amatér jako já, se může něco vytvořit a zúčastnit se) a možnmá se někdy ještě něčeho zúčastním.
        static void Main(string[] args)
        {
            List < Posloupnost > posloupnosti = new List<Posloupnost>();

            string jmeno = "posloupnost";

            NacteniPosloupnosti np = new NacteniPosloupnosti(jmeno);
            posloupnosti = np.Nacteni();

            PocitaniDalsichClenu pdc = new PocitaniDalsichClenu(posloupnosti);
            pdc.SpocitejDalsiCleny();

            Console.ReadKey();
        }
    }
}
